/*---------------------------------------------------------------------*
	Copyright (C) 1997, Nintendo.
	
	File		gxdmem_save.h
	Coded    by	Yoshitaka Yasumoto.	Oct 17, 1997.
	
	$Id: gxdmem_save.h,v 1.1.1.1 2002/05/02 03:29:11 blythe Exp $
 *---------------------------------------------------------------------*/

/*---------------------------------------------------------------------------*
 *  Yield セーブ領域
 *      
 *      Yield の前後で保持される.
 *---------------------------------------------------------------------------*/

	#---------------------------------------------------------------------
	#  頂点データ
	#---------------------------------------------------------------------
			.bound	8
RSP_SAVE_POINTS:	.space	80*16	# F3DEX/F3DLX/L3DEX  32 頂点
					# F3DLX.Rej          64 頂点
					# F3DLP.Rej          80 頂点

	#---------------------------------------------------------------------
	#  Alpha を使用したライト処理の変換テーブル
	#	デーブルをロードする必要がある.
	#---------------------------------------------------------------------
#ifdef	ALPHA_LIGHTING
			.bound	8
RSP_SAVE_ALTBL:		.space	256	# 反射角からの内積値を変換する
			.symbol	RSP_SAVE_ALTBL_OFFSET, RSP_SAVE_ALTBL+0x80
#endif
	
	#---------------------------------------------------------------------
	#  Yield 時のレジスタセーブ用領域  (0x0bf8 〜 0x0bff)
	#---------------------------------------------------------------------
		.symbol	RSP_SAVE_YIELD_INP,   0x0bf8
		.symbol	RSP_SAVE_YIELD_UCODE, 0x0bfc
#ifdef	OUT_xbus
		.symbol	RSP_SAVETMP_YIELD_INP,   RSP_DLINPUT_OFFSET
		.symbol	RSP_SAVETMP_YIELD_UCODE, RSP_DLINPUT_OFFSET+4
#endif

	#---------------------------------------------------------------------
	#  Save サイズ (sptask.h: OS_YIELD_DATA_SIZE を参照)
	#---------------------------------------------------------------------
		.symbol	RSP_SAVE_YIELD_LEN,   0x0c00
			
/*======== End of gxdmem_save.h ========*/
